﻿using System;
using System.IO;
using IglooCoder.Commons.Logging;
using IglooCoder.Demo.AOP.Common;
using IglooCoder.Demo.AOP.Console.Resolver;
using log4net;
using log4net.Config;

namespace IglooCoder.Demo.AOP.Console
{
    internal class Program
    {
        private static void Main(string[] args)
        {
            try
            {
                ConfigureLogging();

                var customerServices = Resolve.For<ICustomerServices>();
                customerServices.Update(new UpdateCustomerDto());
            }
            catch (Exception e)
            {
                Log.For(typeof(Resolve)).Error("Error at startup", e);  
            }
            System.Console.ReadKey();
        }

        private static void ConfigureLogging()
        {
            XmlConfigurator.Configure(new FileInfo("log4net.config"));
            Log.Initialize(new Log4NetLogger(new Log4NetContext(LogManager.GetLogger(typeof (Resolve)))));
            Log.For(typeof (Resolve)).Debug("Logging has been initialized");
        }
    }
}