using IglooCoder.Commons.Logging;
using PostSharp.Laos;

namespace IglooCoder.Demo.AOP.PostSharp.Infrastructure.PostSharpLogging
{
    public class LogThisAttribute:OnMethodBoundaryAspect
    {
        public override void OnEntry(MethodExecutionEventArgs eventArgs)
        {
            Log.For(eventArgs.Instance.GetType().Name).Info
                (string.Format("{0} has started - Post#", eventArgs.Method.Name));
        }

        public override void OnExit(MethodExecutionEventArgs eventArgs)
        {
            Log.For(eventArgs.Instance.GetType().Name).Info
                (string.Format("{0} has finished - Post#", eventArgs.Method.Name));
        }

        public override void OnException(MethodExecutionEventArgs eventArgs)
        {
            Log.For(eventArgs.Instance.GetType().Name)
                .Error("Error", eventArgs.Exception);
                
        }
    }
}