using System;
using Castle.Core.Interceptor;
using IglooCoder.Commons.Logging;

namespace IglooCoder.Demo.AOP.Windsor.Infrastructure.WindsorLogging
{
    public class LoggingAspect:IInterceptor
    {
        public void Intercept(IInvocation invocation)
        {
            Log.For(invocation.TargetType).Info(string.Format(
                "{0} has started - WindsorInterceptor",
                invocation.Method.Name));

            try
            {
                invocation.Proceed();
            }
            catch (Exception e)
            {
                Log.For(invocation.TargetType)
                    .Error("Error occured.", e);

                throw e;
            }
            

            Log.For(invocation.TargetType).Info(string.Format(
                "{0} has finished - WindsorInterceptor",
                invocation.Method.Name));

        }
    }
}