using IglooCoder.Commons.Logging;
using IglooCoder.Demo.AOP.Common;
using IglooCoder.Demo.AOP.Windsor.Infrastructure;
using IglooCoder.Demo.AOP.Windsor.Repositories;

namespace IglooCoder.Demo.AOP.Windsor.Services
{
    public class CustomerServices : ICustomerServices
    {
        private readonly IUpdateCustomerValidator _updateCustomerValidator;
        private readonly ICustomerRepository _customerRepository;

        public CustomerServices(IUpdateCustomerValidator updateCustomerValidator, 
            ICustomerRepository customerRepository)
        {
            _updateCustomerValidator = updateCustomerValidator;
            _customerRepository = customerRepository;
        }

//        public void DoStuff()
//        {
//            var customerRepository = new CustomerRepository();
//            customerRepository.SaveOrUpdate(null);
//        }


        public void Update(UpdateCustomerDto updateCustomerDto)
        {
//            Log.For(this).Info("Windsor.CustomerServices.Update started (old way)");
            if (!_updateCustomerValidator.For(updateCustomerDto))
            {
//                Log.For(this).Info("UpdateCustomerDto failed validation (old way)");
                throw new ValidationException();
            }

            _customerRepository.SaveOrUpdate(updateCustomerDto);
//            Log.For(this).Info("Windsor.CustomerServices.Update finished (old way)");
        }
    }
}